/*<![CDATA[*/

/**
 * Copyright (c) 2010-2019 V.Krishn (insteps.net)
 *
 * This file is part of Cookbook recipe "QNotes" for PmWiki;
 * See accompanying package for license and more details.
 * Package: http://insteps.net/pr/a/pmwiki/Apps/Qnotes
 *
 */

(function( Qnotes, undefined ) {
  var config = Qnotes.Config = function (config) {
    Qnotes.config = config;
  }
  Qnotes.version = qnversionnum; //Config.version
  Qnotes.copyright = 'Copyright (c) 2010-2019 V.Krishn (insteps.net)';
  Qnotes.about = function () {
    alert(
      "\nVersion: "+this.version+
      "\n\nQnotes: \n \(A general purpose short-notes application build on PmWiki\)\n\n"+
      this.copyright);
  }
}( this.Qnotes = this.Qnotes || {} ) );

//var QNOTES_CONFIG = {"nodes" : "qnoteroot"};
//Qnotes.Config(QNOTES_CONFIG);

(function( Qnotes, undefined ) {
  var form = Qnotes.Form = {
    form: qnotesEF,
    url: qnscripturl+'?n='+qncurpgn,
    inputasync: "<input type='hidden' name='qnotesAsync' id='qnotesAsync' value='1' />",
    container: qnotesEFC,
    close: qnotesFrmClose,
    openpage: qnotesOPForm,
    event: function (e) {
      if(e.target.id === 'qnotesFrmClose') { form.hide(); }
      return this;
    },
    init: function () {
      this.form.action = this.url; this.clear().show();
      this.pos0 = this.pos = Position.get(this.container);
      this.hide().close.onclick = this.event;
      return this;
    },
    clear: function () {
      var form = this.form;
      this.update(['/default', '#', '', '', '', '']);
      return this;
    },
    update: function (f) {
      var form = this.form;
      form.qnotesCategory.value = f[0]; form.qnotesTitle.value = f[1];
      form.qnotesLinkToPgName.value = f[2]; form.qnotesLinkTo.value = f[3];
      if(form.qnotesText.innerHTML) {
        form.qnotesText.innerHTML = f[4]; form.qnotesComment.innerHTML = f[5];
      } else { form.qnotesText.value = f[4]; form.qnotesComment.value = f[5]; }
      return this;
    },
    setpos: function (obj, opt) {
      if( Qnotes.ViewBox.pos ) { this.pos = Qnotes.ViewBox.pos; } 
        else { this.pos = Position.get(obj); }
      if(opt === 1) {
        this.pos = Position.get(obj);
        Position.set(this.container, this.pos.left+1, this.pos.top+this.pos.height+1);
      } else {
        Position.set(this.container, this.pos.left+1, this.pos.top+1);
      }
      return this;
    },
    show: function () {
      this.container.style.display = 'block';
      this.container.style.zIndex = 201;
      return this;
    },
    hide: function () {
      Position.set(this.container, this.pos0);
      this.container.style.display = 'none';
      return this;
    },
    showopenpage: function (obj) {
      if(Qnotes.Form.openpage) {
        a = Position.get(obj);
        Position.set(qnotesOPFC, a.left, a.top+a.height);
        qnotesOPFC.style.display = 'block';
        qnotesOPFC.style.zIndex = 203;
      }
    }

  }

  var url = Qnotes.Url = {
    fmt: 0,
    decode: function (doDecode, url, dType) {
      decType = (qnpIsUTF === '1') ? 0 : 2;
      if(dType) decType = dType;
      if(doDecode == '0') decType = 0;
      switch(decType) {
        case 0: return url;
        case 1: return unescape(url);
        case 2: return decodeURI(url);
        case 3: return decodeURIComponent(url);
        default: return url;
      }
    },
    encode: function (doEncode, url) {
      encType = (qnpIsUTF === '1') ? 0 : 2;
      var url = url ? url : qnscripturl+'?n='+qncurpgn+'&qn='+qncategory+'&qnp='+qnpagename;
      if(doEncode == '0') encType = 0;
      switch(encType) {
        case 0: return url;
        case 1: return escape(url);
        case 2: return encodeURI(url);
        case 3: return encodeURIComponent(url);
        default: return url;
      }
    },
    getquery: function (obj) {
      if( ! obj || ! obj.href) { return false; }
      var p = new Poly9.URLParser(Qnotes.Url.decode('1', obj.href));
      return p.getQueryarray();
    }
  }
  
}( Qnotes ) );

(function( Qnotes, undefined ) {
  var viewpane = Qnotes.ViewPane = {
    numx : 0, vp : 'vp0', pos : {},
    init: function (vp) {
      if( ! vp ) { vp = this.vp; }
      this[vp] = document.getElementById('qnViewPane0');
      if( this[vp]) { this.setpos(vp); this.numx++; }
      return this;
    },
    setpos: function (vp) {
      this['vp0'].style.zIndex = 100;
      this.pos[vp] = Position.get(this[vp]);
      return this;
    }
  }

  var viewbox = Qnotes.ViewBox = {
    maxwidth: 300, clicksInit: 0, mousedownsInit: 0,
    b0: document.getElementById('qnotesAction'),
    init: function () {
      if (typeof this.clicks == 'undefined') this.clicks = [];
      if (typeof this.mousedowns == 'undefined') this.mousedowns = [];
      this.clicks.push(this.event); 
      Qnotes.ViewBoxMenu.init('m0');
      return this;
    },
    event: function (e) {
      if(e.target.id === 'closeQnoteBox') { viewbox.hide(); }
      return this;
    },
    setpos: function (pos) {
      w = Position.get(Qnotes.body);
      if(Qnotes.ViewPane[pos]) {
        Qnotes.ViewPane.setpos(pos);
        var pos = Qnotes.ViewPane.pos[pos];
      }
      if(typeof pos == 'object') {
        this.maxwidth = pos.width-3;
        this.b0.style['height'] =  pos.height-6+'px';
        Position.set(this.b0, pos.left+1, pos.top+1);
      } else {
        if(Qnotes.Active.etype == 'list') {
          this.pos = Position.get(Qnotes.Active.lnode);
          this.maxwidth = (w.width - this.pos.left) + w.left - 12;
        } else {
          this.pos = Position.get(Qnotes.Active.node);
          this.maxwidth = this.pos.width;
        }
        Position.set(this.b0, this.pos);
      }
      this.b0.style['width'] =  this.maxwidth+'px';
      this.pos = Position.get(this.b0);
      Qnotes.ViewBoxMenu.setpos('m0', this.pos);
      Qnotes.Loading.setpos(this.pos);
      return this;
    },
    show: function () {
      this.b0.style.display = 'block';
      this.b0.style['height'] = 'auto';
      this.b0.style.zIndex = 201;
      Qnotes.Form.hide();
      Qnotes.ViewBoxMenu.show('m0');
      return this;
    },
    hide: function () {
      this.b0.style.display = 'none';
      Qnotes.ViewBoxMenu.hide('m0');
      return this;
    }
  }
  
  var loading = Qnotes.Loading = {
    init: function () {
      divTag = document.createElement("div"),
      divTag.id = 'qnotesloadingcontainer';
      Qnotes.body.appendChild( divTag );
      this.loading = document.getElementById(divTag.id);
      this.loading.innerHTML = Qnotes.Res.loading;
      this.show().setpos().hide();
      return this;
    },
    setpos: function (pos) {
      if( ! this.pos ) { this.pos = Position.get(this.loading); }
      if( pos ) {
        Position.set(this.loading, pos.left+5, pos.top+2);
      }
      return this;
    },
    show: function () {
      this.loading.style.display = 'block';
      this.loading.style.position = 'absolute';
      this.loading.style.zIndex = 202;
      return this;
    },
    hide: function () {
      this.loading.style.display = 'none';
      return this;
    }
  }
  
  var viewboxmenu = Qnotes.ViewBoxMenu = {
    numx : 0, menu : 'm0',
    m0: document.getElementById('qnotesActionBar'), //default qnote menu
    init: function (menu) {
      //qnotesActionBar - menu over active qnote
      if( ! menu ) { menu = this.menu; }
      this[menu].style.display = 'block';
      this.setpos(menu, '');
      this[menu].style.display = 'none';
      this[menu].style.position = 'absolute';
      this.numx++;
      return this;
    },
    setpos: function (menu, pos) {
      if(pos) {
        Position.set(this[menu], pos.left, pos.top-this[menu].pos.height);
      }
      this[menu].pos = Position.get(this[menu]);
      return this;
    },
    show: function (menu) {
      this[menu].style.display = 'block';
      return this;
    },
    hide: function (menu) {
      this[menu].style.display = 'none';
      return this;
    }
  }

  var listnode = Qnotes.List = {
    numx : 0, lst : 'l0',
    init: function (lst, obj) {
      if( ! lst ) { lst = this.lst; } this[lst] =  obj;
      this.numx++; return this;
    },
    getnode: function (lst, title, sel) {
      if( ! lst ) { lst = this.lst; }
      var a = $(this[lst]).cssSelect(Qnotes.Selector[sel]('', title));
      if(a.length > 0) { if('link0' == sel) { return a; } else { return a.first(); } }
      return false;
    },
    prev: function (lst, title) {
      var pt = this.parentTitle(title); var a = this.firstDecendant(lst, pt);
      a.each(function(elm, idx, set) {
        if(title == elm.title) {
          if( (idx-1) > -1) { ln = set[idx-1]; }
            else { ln = listnode.getbytitle(lst, pt); }
        }
      }); return ln;
    },
    next: function (lst, title) {
      var pt = this.parentTitle(title); var a = this.firstDecendant(lst, pt);
      a.each(function(elm, idx, set) {
        if(title == elm.title) { if( (idx+1) <= set.length) { ln = set[idx+1]; } }
      }); return ln;
    },
    parentTitle: function (title) { var r = title.split('/'); r.pop(); return r.join('/'); },
    hasChildNode: function (lst, title) { return this.getnode(lst, title+'/', 'link0'); },
    firstDecendant: function (lst, title) { //parentTitle
      var obj = this.hasChildNode(lst, title);
      var b2 = obj.filter(function(elm, idx, set) {
        var b = (/(.*)\/([^\/]*)$/i).exec(elm.title);
        return (b[1] == title);
      }); return b2;
    },
    getbytitle: function (lst, title) { return this.getnode(lst, title, 'link1'); },
    triggerbytitle: function (lst, title) {
      ln = this.getbytitle(lst, title); if(ln) ln.triggerEvent("mousedown");
    },
    expand0: function (item) {
      jts = item.parentNode.parentNode;
      str = (jts.className || jts.id);
      if(
        ( str.indexOf('treemenu') > -1 || str.indexOf('treemenudiv') > -1 )
        && jts.style.display == 'none'
      ) {
        if(jts.tagName == 'UL') {
          p = jts.parentNode; cls = p.className;
          if((cls.indexOf('expand') > -1) || (cls.indexOf('collapse') > -1) ) {
            f = p; } else { f = p.cssSelect("span[class*=expand]").first(); }
          } else {
            p = jts.prev(); f = p.cssSelect(":nth-child(1)").first();
            if(f.className.indexOf('space') > -1) { f = p.cssSelect("[class*=expand]").first(); }
            if(f.tagName == 'IMG') { f = p.cssSelect("a").first(); }
          }
        f.triggerEvent("mousedown");
      } return this;
    }
  }

}( Qnotes ) );

(function( Qnotes, undefined ) {
  var active = Qnotes.Active = {
    init: function (qnote, etype) {
      this.node = qnote;
      this.title = this.node.title;
      switch(etype) {
        case 1: this.etype = 'node'; qncategory = this.title; break;
        case 2: this.etype = 'list'; break;
      }
      return this;
    }
  }
  var res = Qnotes.Res = {
    closebtn: '<span id="closeQnoteBox">X</span>',
    loading: '<img border="0" id="qnotesloading" src="'+qnotesurlpath+'/lib/img/loading.gif'+'" />',
    mask1: '<div id="qnmask1" style="background-color:transparent;">&nbsp;</div>',
    newnote: '<h3>_new note_ !</h3><div class="text"><blink>Edit to create.</blink> <i>Qnote > Edit</i></div>'
  }
  var msg = Qnotes.Msg = {
    saved: 'Data saved...',
    deleted: 'Qnote deleted...',
    error: '<div id="qnpostresponse"><div class="error">Error... <br>Please try again.</div></div>',
    saving: '<div id="qnpostresponse"><div class="msg">Saving....</div></div>'
  }
  var selector = Qnotes.Selector = {
    rootClass: 'qnoteroot',
    rootTitle: function (qnp) { return (qnp !== '') ? qnp.replace(/[\/\.]/g, '_') : false; },
    root0: function (qnp) { return '#'+qnp; },
    root: function (qnp) { return '.qnoteroot[title="'+qnp+'"]'; },
    qnote1: function (qnp, qn) { return "div[title='" + qn + "']"; },
    link0: function (qnp, qn) { return "a.phplm[title^='" + qn + "']"; },
    link1: function (qnp, qn) { return "a.phplm[title='" + qn + "']"; }
  }
}( Qnotes ) );

DOMAssistant.Qnotes = function () {
  var Init = Qnotes.Init = {
    loading: function () {
      Qnotes.body = $(document.body);
      Qnotes.root = $$('qnoteroot'); //qnotes
      Qnotes.Loading.init();
      Qnotes.ViewBox.init();
      Qnotes.ViewPane.init();
      Qnotes.Form.init();
      Init.root(qnpagename);
      $('#qnoteroot').Qnotes();
      $('#qnotesActionBar').QnoteMenu();
      $('#qnotesAppAction').QnotesAppMenu();
      Qnotes.body.create("div", { id : "qnoteitem", title: "" }, true, "<a id='qnoteitem1'></a>");
      $('#qnotesList1-wrapper').QnotesList();
      Qnotes.Active.lnode = '';
      $('#qnoteitem').QnotesItem();
      //qnotesEditForm
      $('#qnotesEditForm').setAJAXForm(HandleBeforeSave, PostResponseHandler);
      qnotesEF.onsubmit = function() { return false; };
      qnotesBox = $(Qnotes.ViewBox.b0);
      qnotesAB = Qnotes.ViewBoxMenu.m0;
      if(typeof Init.qnoteext == 'undefined') { Init.qnoteext = []; }
      Init.refresh = 0;
    },
    qnote: function (e) {
      DOMAssistant.cancelBubble(e);
      active = Qnotes.Active; var o = e.target;
      if(o) { //node on datapage
        if(o.parentNode.title.length <= 1) { return this; }
        if(o.tagName !== 'H3') { return this; }
        active.init(o.parentNode, 1); qnpagename = qncurpgn;
      } else {
        active.init(e, 2);
      }
      if($(active.node).hasClass("comment") == true) { return this; }
      objQnote = active.node;
      setTimeout(function() { ViewBox.refresh(3); }, 100); //important
      return this;
    },
    root: function (qnp) {
      qnp = (typeof qnp == 'undefined') ? qnpagename : qnp;
      var title = Qnotes.Selector.rootTitle(qnp);

      root = $$('qnoteroot');
      if(root !== null && root.title == '/') {
        root.title = title; root.className = Qnotes.Selector.rootClass; }

      if( ! this.setroot(title)) {
        Qnotes.body.create("div", {'id': title, 'class': "qnoteroot", 'title': title }, true, "");
        if(this.setroot(title)) { Qnotes.root.style.display = 'none'; }
      }
    },
    setroot: function (t) {
      t = Qnotes.Selector.rootTitle(t);
      if(qndisplaymethod == 'multiple') {
        Qnotes.root = $$('qnoteroot'); if(Qnotes.root.title == t) { return true; } }
      r = Qnotes.body.cssSelect(Qnotes.Selector.root0(t));
      if(r && r.length > 0) { Qnotes.root = r.first(); return true; } else { return false; }
    },
    node: function (qnp, obj) {
      Qnotes.root.create("div", { title: obj.title }, true, '');
      return objQnote = this.getnode(qnp, obj.title, 'node');
    },
    getnode: function (qnp, title, opt) {
      if( ! this.setroot(qnp)) { Init.root(qnp); }
      s = Qnotes.Selector.qnote1(qnp, title);
      switch(opt) {
        case 'h3': r = s + " > h3"; node = Qnotes.root.cssSelect(r); break;
        case 'text': r1 = s + " > div"; node = Qnotes.root.cssSelect(r1); break;
        case 'node': node = Qnotes.root.cssSelect(s); break;
      }
      if(node.length > 0) { return node.first(); }
      return false;
    },
    async: function (callback) {
      url = Qnotes.Url.encode();
      HandleAsync(url, objQnote, callback, Qnotes.Url.fmt);
      return this;
    },
    url: function (obj) {
      var p = new Poly9.URLParser(Qnotes.Url.decode('1', obj.href));
      q = p.getQueryarray(); qncategory = q.qn;
      if ( ! obj.title ) { obj.title = qncategory; }
      qncurpgn = (q.n) ? q.n : qncurpgn; qnpagename = q.qnp;
      u = p.getProtocol() + '://' + p.getHost() + p.getPathname();
      qnmisc=''; for(x in q) {if(! (x == 'n'|| x == 'qnp'|| x == 'qn') ) {
        qnmisc = qnmisc + '&'+x+'='+q[x]; }};
      return qnmisc;
    }
  }

  var ViewBox = {
    QVB: Qnotes.ViewBox,
    show: function () {
      this.QVB.show();
      if ( this.QVB.b0.display == 'none') { //see sectiodEdit
        this.QVB.b0.style.visibility = 'hidden'; }
      return this;
    },
    refresh: function (opt) {
      if(opt == 3) { this.fill().comments(0).show().setpos().settitle(); }
      if(opt == 1) { this.fill().comments(0).settitle(); }
      setTimeout(function() { ViewBox.qnoteext(); }, 200);
      return this;
    },
    hide: function () { this.QVB.hide(); return this; },
    resize: function () {
      if(qnotesBox.style.display == 'block') {
        ViewBox.hide(); setTimeout(function() { ViewBox.show().setpos(); }, 500); }
      return this;
    },
    setpos: function () {
      this.QVB.setpos('vp0'); FrmBox.setpos(1);
      return this;
    },
    fill: function () {
      qnotesBox.replaceContent(Qnotes.Res.closebtn);
      qnotesBox.addContent(objQnote.innerHTML);
      r = qnotesBox.elmsByAttribute("title", "/", "div");
      r.each( function(elm, idx, set) {
        if (typeof elm == 'object' && elm.title !== ''
        && elm.parentNode !== null && $(elm).hasClass("comment") == false)
          { $(elm).remove(); }
      });
      return this;
    },
    comments: function (isShow) {
      this.comment = qnotesBox.elmsByAttribute("class", "comment", "div");
      if(isShow == 0) { $(this.comment).setStyle({ display: "none" }); }
      if(isShow == 1) { $(this.comment).setStyle({ display: "block" }); }
      if(isShow == 2) {
        this.comment.each( function(elm, idx, set) {
          d = $(elm).getStyle("display");
          if (d == 'none' || d == '') { elm.setStyle({ display: "block" }); return this; }
          if (d == 'block') { elm.setStyle({ display: "none" }); return this; }
        });
      }
      return this;
    },
    settitle: function () {
      c1 = qnotesBox.cssSelect(":nth-child(2)");
      c2 = qnotesBox.cssSelect(":nth-child(3)");
      if( ! c1.first()) { return this; }
      c1.first().title = c1.first().innerHTML;
      c1.first().addClass('fheading');
      c2.first().title = qnpagename+': '+Qnotes.Active.title;
      this.fixheight(c1, c2); //maynot be needed
      return this;
    },
    fixheight: function (c1, c2) {
      if(Qnotes.ViewPane['vp0'] == null) {
        c2.first().setStyle({ height: 200 +'px !important' }); return this;
      }
      vp1 = Qnotes.ViewPane.pos.vp0; if( ! vp1) return this;
      b = Position.get(c1.first());
      c2.first().setStyle({ height: vp1.height-b.height-6 +'px !important' });
      return this;
    },
    qnoteext: function () {
      for(var i=0; i < Init.qnoteext.length; i++) { 
        if(typeof Init.qnoteext[i] == 'function') { Init.qnoteext[i](); }
      }
      if(this.QVB.clicksInit == 0) {
        for(var i=0; i<this.QVB.clicks.length; i++) {
          this.QVB.clicksInit = 1; this.QVB.b0.addEvent("click", this.QVB.clicks[i]);
        }
      }
      if(this.QVB.mousedownsInit == 0) {
        for(var i=0; i<this.QVB.mousedowns.length; i++) {
          this.QVB.mousedownsInit = 1; this.QVB.b0.addEvent("mousedown", this.QVB.mousedowns[i]);
        }
      }
      return this;
    }
  }
  
  var FrmBox = {
    setpos: function (opt) {
      a = '147px'; b = '142px';
      if(opt === 1) { a = Qnotes.ViewBox.pos.width-8+'px'; b = '60%'; }
      qnotesEFC.style.width = a;
      r = $(qnotesEF).elmsByAttribute('type', 'text', 'input');
      r.each( function(elm, idx, set) { $(elm).style.width = b; });
      return this;
    },
    show: function (obj, opt) {
      Qnotes.Form.setpos(obj, opt).show(); this.settitle().fixheight();
      return this;
    },
    settitle: function () {
      r1 = $(qnotesEF).elmsByAttribute('class', 'heading', 'span').first();
      t = 'QNotes (editing - '+qnpagename+')'; r1.replaceContent(t);
      r1.title = qnpagename; return this;
    },
    fixheight: function() {
      vp0 = Qnotes.ViewPane.pos.vp0; if( !vp0) { return this; }
      h = vp0.height-10; r = qnotesEF.getElementsByTagName('textarea');
      r[0].style.height = h-117+'px'; r[1].style.height = h-159+'px';
      return this;
    },
    hide: function () { Qnotes.Form.hide(); return this; },
    resize: function () {
      if(qnotesEFC.style.display == 'block') {
        setTimeout(function() { ViewBox.show().setpos(); 
        FrmBox.setpos(1).show().fixheight(); ViewBox.hide(); }, 200); }
      return this;
    },
    editnew: function () {
      ViewBox.hide(); Qnotes.Form.clear();
      qnotesEF.qnotesPage.value = qnpagename;
      return this;
    }
  }

  return {
    publicMethods : [
      "Qnotes", "QnotesAppMenu", "QnoteMenu", "QnotesList",
      "QnotesItem", "ResetPos", "QnotesRefresh",
      "Login", "LoginLink", "IsAuthReqired"
    ],
    
    init : function () {
      DOMAssistant.DOMReady(function() {
        $ = DOMAssistant.$; $$ = DOMAssistant.$$;
        Init.loading();
        window.onresize = function() { ViewBox.resize();  FrmBox.resize(); }

        if(typeof Qnotes.Ready == 'undefined') { Qnotes.Ready = []; }
        for(var i=0; i < Qnotes.Ready.length; i++) {
          if(typeof Qnotes.Ready[i] == 'function') { Qnotes.Ready[i](); }
        }
        $(qnotesBox).relayEvent("mouseup", "a.qnote", QnotesLink);
        $(qnotesBox).relayEvent("mouseup", "span.qnote a", QnotesLink);
      });
    },
    ResetPos : function () {
      if(qnotesEFC.style.display == 'block') { FrmBox.resize(); }
      if(qnotesBox.style.display == 'block') { ViewBox.setpos(); }
      return this;
    },
    Qnotes : function () {
      this.removeEvent("mousedown", Init.qnote);
      this.addEvent("mousedown", Init.qnote);
      return this;
    },
    QnoteMenu : function () {
      this.addEvent("mousedown", QnoteMenu);
      return this;
    },
    QnotesAppMenu : function () {
      this.addEvent("mousedown", QnotesAppMenu);
      return this;
    },
    QnotesItem : function () {
      this.style.display = 'none';
      this.addEvent("mousedown", QnotesItem);
      Qnotes.item = $$('qnoteitem1');
      Qnotes.item.fetchmode = 'static';
      return this;
    },
    QnotesList : function () {
      Qnotes.List.init('l0', this);
      this.addEvent("mousedown", QnotesList);
      return this;
    },
    QnotesRefresh : function (rdata, str, isNR, isBRS) {
      if( ! isNR) isNR = 1; if( ! isBRS) isBRS = 0;
      if (AsyncSuccess(rdata, str)) {
        Qnotes.Loading.hide(); ViewBoxRefresh(rdata, isNR, isBRS);
      }
    },
    IsAuthReqired : function (rdata) { return IsAuthReqired(rdata); },
    Login : function (frm) { Login(frm); return this; },
    LoginLink : function (e) { LoginLink(e); return this; }
  };

  /*
   * Menus / Clickables
   */
  function QnoteMenu(e) {
    DOMAssistant.cancelBubble(e);
    switch(e.target.innerHTML) {
      case 'New':
        FrmBox.editnew().show(qnotesAB, 0);
      break;
      case 'Edit':
//         if(objQnote.innerHTML == '') {
//           Qnotes.item.triggerEvent("mousedown");
//           setTimeout(function() { Qnotes.Url.fmt = 0; Init.async(updateEditForm); }, 300);
//         } else { Qnotes.Url.fmt = 0; Init.async(updateEditForm); }
        Qnotes.Url.fmt = 0; Init.async(updateEditForm);
      break;
      case 'Refresh':
//        Init.refresh = 1; Qnotes.Url.fmt = 1; Init.async(HandleRefresh);
        if(objQnote.innerHTML !== '') {
          Init.refresh = 1; Qnotes.Url.fmt = 1; Init.async(HandleRefresh); }
      break;
      case 'Close':
        ViewBox.hide();
      break;
      case 'Comment':
        ViewBox.comments(2);
      break;
      case 'About Qnotes':
        Qnotes.about();
      break;
    }
    return;
  }
  function QnotesAppMenu(e) {
    DOMAssistant.cancelBubble(e);
    switch(e.target.innerHTML) {
      case 'New':
        FrmBox.editnew().show(this, 1);
      break;
      case 'Open':
        Qnotes.Form.showopenpage(this);
      break;
      case 'Hide':
        Qnotes.List.l0.style.display = 'none';
        e.target.innerHTML = 'Show';
      break;
      case 'Show':
        Qnotes.List.l0.style.display = 'block';
        e.target.innerHTML = 'Hide';
      break;
      case 'About Qnotes':
        Qnotes.about();
      break;
    }
    return;
  }
  function QnotesItem(e) {
    Qnotes.Event = 'Item';
    if(e.target.tagName !== 'A') { return this; }
    obj = $(e.target); obj.onclick = function() { return false; }
    
    qnmisc = Qnotes.Init.url(obj);
    window.location = '#'+obj.title;

    objQnote = Init.getnode(qnpagename, obj.title, 'node');
    Qnotes.Active.title = obj.title;

    if(qndisplaymethod == 'single') { //single
      qnotesEF.qnotesPage.value = qnpagename;
      if(qnfetchmode == 'async') { Qnotes.root.remove(); }
      if( ! objQnote) {
        objQnote = Init.node(qnpagename, obj);
        if(!objQnote) objQnote = Init.node(qnpagename, obj);
        Init.async(HandleItem); return false;
      }
    } else {
      if( ! objQnote) {
        objQnote = Init.node(qnpagename, obj);
        Init.refresh = 1; Init.async(HandleRefresh); return false;
      } else {
        ViewBox.refresh(3); return false;
      }
    }
    Init.qnote(objQnote);
//     if (Qnotes.item.fetchmode == 'async') {
//       setTimeout(function() { objQnote.remove(); }, 300);
//       Qnotes.item.fetchmode = 'static';
//     }
    return false;
  }
  function HandleItem(rdata) {
    HandleRefresh(rdata);
    Init.qnote(objQnote);
    if(Qnotes.item.fetchmode == 'async') {
      objQnote = Init.getnode(qnpagename, obj.title, 'node');
      setTimeout(function() { objQnote.remove(); }, 300);
      Qnotes.item.fetchmode = 'static';
    }
    return false;
  }
  function QnotesList(e) {
    DOMAssistant.cancelBubble(e); var o = e.target;
    if(o.tagName == 'IMG') {
      if(o.parentNode.tagName == 'A') {
        obj = $(o.parentNode);
        obj.onclick = function() { return false; }
      } return;
    }
    if(o.tagName == 'A' || o.tagName == 'SPAN') {
      obj = $(o);
      if ($(obj.parentNode).hasClass('text')) {
        obj = $(obj.parentNode.parentNode); }
      if ($(obj).hasClass('text')) {
        obj = $(obj.parentNode); }
      if(obj.title == '') { return; }
      obj.onclick = function() { return false; }
      
      if(Qnotes.Active.lnode) {
        Qnotes.Active.lnode.removeClass('active'); }
      obj.addClass('active');

      Qnotes.Url.fmt = 1;
      Qnotes.Active.lnode = obj;
      Qnotes.Active.etype = 'list';
      Qnotes.item.title = obj.title; Qnotes.item.href = obj.href;
      Qnotes.item.triggerEvent("mousedown");

    }
    return false;
  }
  function QnotesLink(e) {
    obj = $(e.target); obj.onclick = function() { return false; }
    Qnotes.item.title = obj.title; Qnotes.item.href = obj.href;
    q1 = Qnotes.Url.getquery(obj); if(!q1.qnp) { q1.qnp = qnpagename; }
    if ($(obj).hasClass('async') || $(obj.parentNode).hasClass('async')) {
      Qnotes.item.fetchmode = 'async';
      n = Qnotes.Init.getnode(q1.qnp, q1.qn, 'node'); if(n) { n.remove(); }
    }
    if( Qnotes.item.title == '') {
      if ( ! q1.qn || ! q1.qnp ) {  return false; }
      if(la = Qnotes.List.getbytitle('l0', q1.qn)) {
        q2 = Qnotes.Url.getquery(la);
        if(q1.qnp == q2.qnp ) {
         Qnotes.List.triggerbytitle('', q2.qn); Qnotes.List.expand0(la); 
         return false;
        } 
      }
    }
    Qnotes.item.triggerEvent("mousedown");
    return false;
  }

/*
 * Async functions
 * ----------------
 */
function HandleAsync(url, objQnote, callback, fmt) {
  Qnotes.Loading.show();
  switch(fmt) {
    case 0: u1 = '&async=1&qfmt=wiki&action=qnotes'; break;
    case 1: u1 = '&async=1&qfmt=html&action=qnotes'; break;
    case 2: u1 = ''; break;
    default: u1 = '&async=1&action=qnotes'; break;
  }
  if(typeof qnmisc == 'undefined') { qnmisc = ''; } url = url + u1 + qnmisc;
  //console.log('HandleAsync 0:: '+url);
  $(objQnote).ajax({
    url : url,
    method : "GET",
    params : "name=qnotesGet",
    callback : callback,
    headers : {
      "Content-type" : "text/plain"
    },
    responseType : "text",
    timeout : 5000,
    exception : function(e) {
      alert("Async error: " + (e.message || e.description));
    }
  });
  return;
}
function AsyncSuccess(rdata, str) {
  if (DOMAssistant.AJAX.getStatus() ==  200 &&
      DOMAssistant.AJAX.getReadyState() == 4)
  {
    Qnotes.Loading.hide();
    if(str && str.length > 0 && rdata.indexOf(str) == -1) { return false; }
    return true;
  }
  return false;
}
function HandleBeforeSave() {
  qnotesEF.addContent(Qnotes.Form.inputasync);
  qnotesBox.replaceContent(Qnotes.Msg.saving);
  wp = Position.get(qnotesEFC);
  ww = $(qnotesEFC).getStyle("height");
  Position.set($(qnotesBox), wp);
  qnotesBox.setStyle({ height: ww, width: wp.width+'px', 
    display: 'block', visibility: 'visible' });
  posterr = setTimeout(function() { PostErrorHandler(); }, 12000);
}
function PostResponseHandler(rdata) {
  if (AsyncSuccess(rdata)) {
    if(rdata) {
      clearTimeout(posterr);
      // isLogin/AuthRequred
      if($(qnotesBox).IsAuthReqired(rdata)) { return false; }
      $(qnotesBox).innerHTML = rdata;
      msg = $(qnotesBox).elmsByAttribute('class', 'msg', 'div').first();
      msg = (msg) ? msg.innerHTML : '';
    }
    if( isDeleted(msg) ) {
      if(Qnotes.Active.etype == 'list') {
        var t = Qnotes.Active.title;
        if( ! Qnotes.List.hasChildNode('', t)) {
          prev = Qnotes.List.prev('', t).title;
          node = Qnotes.List.getbytitle('', t).parentNode;
          setTimeout(function() {
            $(node).remove(); Qnotes.List.triggerbytitle('', prev);
            pn = Qnotes.List.hasChildNode('', prev);
            lnA = Qnotes.List.getbytitle('', prev).parentNode;
            if( ! pn ) {
              p2 = Qnotes.List.next('', prev);
              if(p2) { lnA.className = 'split'; } else { lnA.className = ''; }
            } else {
              lnA.className = 'collapse_corner'; //@ TODO
            }
          }, 100);
          return;
        }
      }
    }
    if(isSaved(msg)) {
      Qnotes.Form.clear(); qnshow = (qndisplaymethod == 'single') ? 1 : 0;
      setTimeout(function() { ViewBox.hide(); FrmBox.hide(); ViewBoxRefresh(rdata, 1, qnshow); }, 2000);
    }
  } else {
    PostErrorHandler(msg);
  }
}
function PostErrorHandler(msg) {
  if( ! isSaved(msg)) {
    qnotesBox.replaceContent(Qnotes.Msg.error);
    setTimeout(function() { ViewBox.hide(); FrmBox.hide(); }, 2000);
  }
}
function isSaved(msg) {
  return AsyncSuccess(msg, Qnotes.Msg.saved);
}
function isDeleted(msg) {
  return AsyncSuccess(msg, Qnotes.Msg.deleted);
}
function ViewBoxRefresh(rdata, isNodeRefesh, isBoxReShow) {
  $(qnotesBox).replaceContent(rdata);
  r = $(qnotesBox).elmsByAttribute("title", '', "div");
  r1 = $(r).first().elmsByAttribute("class", 'refreshdata', "div");
  
  if(isNodeRefesh === 1) {
    title = Qnotes.Active.title;
    switch(Qnotes.Active.etype) {
      case 'list': if (Qnotes.Active.lnode.title == Qnotes.Active.title ) {
          title = r.first().title; } break;
      case 'node': if (Qnotes.Active.title !== r.first().title ) {
          title = r.first().title; } break;
    }
    rdata = r1.first().innerHTML;
    if(rdata == '') { rdata = Qnotes.Res.newnote; }
    NodeRefresh(rdata, title);
  }
  
  if(isBoxReShow === 1 && typeof(objQnote) != 'undefined') {
    setTimeout(function() { ViewBox.refresh(3); }, 100); //important
  } else { if(Init.refresh == 1) { ViewBox.refresh(3);} }
  Init.refresh = 0;
}
function NodeRefresh(rdata, t) {
  obj = Init.getnode(qnpagename, t, 'node');
  if(! obj) { window.location = Qnotes.Form.url; return; }

  h3 = Init.getnode(qnpagename, t, 'h3');
  text = Init.getnode(qnpagename, t, 'text');
  if(h3) { h3.remove(); }
  if(text && text.title == '') { text.remove(); }

  obj.replaceContent(rdata+obj.innerHTML);
}
function HandleRefresh(rdata) {
  if (AsyncSuccess(rdata)) {
    Qnotes.Loading.hide();
    ViewBoxRefresh(rdata, 1, 0);
  }
}
function updateEditForm(rdata) {
  if (AsyncSuccess(rdata)) {
    FrmBox.editnew();
    rdata = rdata.replace(/\<\/g/i, '&lt;/g');
    $(qnotesBox).innerHTML = rdata;
    r1 = $(qnotesBox).cssSelect("div[title] > div"); f5 = r1[2].innerHTML
    f5 = f5.replace(/&gt;/ig, '>').replace(/&lt;/ig, '<').replace(/&amp;/ig, '&');
    if(r1.length > 3) {
      qnotesIsLink.checked = true; toggleQNotesLinkFrm();
      f3 = r1[3].innerHTML; f4 = r1[4].innerHTML;
      f5 = 'linked-note'; f6 = r1[5].innerHTML; 
    } else { f3=''; f4=''; f6=''; qnotesIsLink.checked = false; toggleQNotesLinkFrm(); }
    Qnotes.Form.update([r1[0].innerHTML, r1[1].innerHTML, f3, f4, f5, f6]);
    FrmBox.show(); Qnotes.Url.fmt = 1; Qnotes.Loading.hide();
  }
  return;
}

function Login(frm) {
  if(typeof login == 'undefined') { login = {};
    login.prev_qn = Qnotes.item.title; login.prev_href = Qnotes.item.href;
  }
  try { frm.authid.focus(); } catch(e) { frm.authpw.focus(); }
  frm.setAJAXForm( function() {
      Qnotes.Loading.show(); frm.action = Qnotes.item.href+'&async=1&qfmt=html&action=qnotes';
    }, function(rdata) { if (AsyncSuccess(rdata)) {
      n = Qnotes.Init.getnode(qnpagename, login.prev_qn, 'node'); if(n) n.remove();
      Qnotes.item.title = login.prev_qn; Qnotes.item.href = login.prev_href;
      setTimeout(function() { Qnotes.Url.fmt = 1; Qnotes.item.triggerEvent("mousedown"); }, 300);
    }; return false; });
  frm.onsubmit = function() { return false; }
}
function LoginLink(e) {
  login = {}; login.prev_qn = Qnotes.item.title; login.prev_href = Qnotes.item.href;
  obj = $(e.target); obj.onclick = function() { return false; }
  qnp = qnpagename; qn = '/site~/login'; Qnotes.item.title = qn;
  Qnotes.item.href = obj.href+"&qnp="+qnp+"&qn="+qn;
  Qnotes.Url.fmt = 2; Qnotes.item.triggerEvent("mousedown");
  return false;
}
function IsAuthReqired(rdata) {
  var r = (/type\=[\'\"]password[\'\"](.*)name\=[\'\"]authpw[\'\"]/i).exec(rdata);
  if(r) { $(qnotesBox).innerHTML = rdata; }
  frm1 = $(qnotesBox).elmsByTag('form').first();
  if(frm1 && frm1['authpw']) {
    rdata = rdata.replace('<div title="">', '<div title="'+Qnotes.item.title+'">');
    $(qnotesBox).QnotesRefresh(rdata, '', 1, 1);
    setTimeout(function() { $(qnotesBox).Login(frm1); }, 500); return true;
  }
  return false;
}
 
}();

DOMAssistant.attach(DOMAssistant.Qnotes);
DOMAssistant.harmonize();

var _qnotes_apps = function() {

  // Init INFOBOX
  if(typeof ib !== 'undefined') { ib.infoinit(); }
  $('#qnotesActionBar2').QnoteMenu();
  Qnotes.Init.qnoteext.push(QnoteLogin);

}
QnoteLogin = function() {
  //if( ! qnIsAuthEdit) return;
  frms = $(qnotesBox).elmsByTag('form'); if(frms.length < 1) { return; }
  frm1 = $(frms).first(); // Login form
  if(frm1['authpw']) { $(qnotesBox).Login(frm1); } else { return false; }
  frm1.onsubmit = function() { return false; }
}


Qnotes.Ready.push(_qnotes_apps);

/*]]>*/

