<?php if (!defined('PmWiki')) exit();
/**
 * qnotes.createpage.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2010-2019
 * @note This file is part of Cookbook recipe "QNotes" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package qnotes
 */

// **********************************************************
// Qnotes create page
// **********************************************************
/*
  Directive
    (:qnotes idNum createpage <pagename>
       type=data template='Templates.QNotes':)
    
    1. ID - unique id (alpha-numeric)
    2. createpage - create a wikipage.
    3. pagename = name of the page(fmt - Group.Name).
    4. type - type of qnotes page
             (data|homepage|manager|navigator|presenter|sectionedit).
         data - basic qnotes datapage.
         sectionedit - qnotes datapage with sectionedit behaviour.
         homepage,manager - basic qnotes manager.
         navigator - qnotes navigator behaviour.
         presenter - qnotes presenter behaviour.
    5. template = name of the template to create page from (fmt - Group.Name).

*/

global $QNotes, $qnotesOutFmt, $pagename;

  $qnPageName = &$args[''][2];
  $TimeFmt = '%b %d, %Y, %I:%M%P';
  $qnPageType = &$args['type'];

  if ( isset($qnPageType)) {
    switch ($qnPageType) {
      case 'data':
        $template = 'QNotes.Template';
        break;
      case 'sectionedit':
        $template = 'QNotes.Template-SectionEdit';
        break;
      case 'homepage':
        $template = 'QNotes.HomePage';
        break;
      case 'manager':
        $template = 'QNotes.HomePage';
        break;
      case 'navigator':
        $template = 'QNotes.Navigator';
        break;
      case 'presenter':
        $template = 'QNotes.Presenter';
        break;
      default:
        $template = 'QNotes.Template';
        break;
    }
  }

  if ( isset($args['template'])) { $template = $args['template']; }

  if ( isset($qnPageName)) {
    $pn = MakePageName($pagename, $qnPageName);
    if($pn == '') { $qnotesOutFmt = "'''Incorrect pagename format.'''<br>"; return; }
  } else {
    $qnotesOutFmt = "%red%Pagename not provided.<br>"; return;
  }

  // Create page
  // ------------------------------
  if( ! PageExists($pn) ) {
    $qnotesOutFmt = "%green%Creating Qnotes page: %maroon%".$pn.'%%<br>';
    $QNotes['isDiff'] = 0;
    $QNotes['EditFunctions'] = array('PostPage');
    $msg = CreateQnotesPage($pn, $template, 2);
    if( $msg === 1 ) { $qnotesOutFmt = "'''$pn exists.'''<br>"; return; }
    if( $msg === 2 ) { $qnotesOutFmt = "%blue%Qnotes template ''$template'' does not exists.<br>"; return; }
  } else {
    $qnotesOutFmt = "'''$pn''' ''exists, nothing done.''<br>"; return;
  }

  return;



